import * as unplugin_combine_types from 'unplugin-combine/types';
import { Options as Options$1 } from '@vue-macros/define-model';
import { Options as Options$2 } from 'unplugin-vue-define-options';
import { Options as Options$3 } from '@vue-macros/define-render';
import { Options as Options$4 } from '@vue-macros/define-slots';
import { Options as Options$5 } from '@vue-macros/hoist-static';
import { Options as Options$6 } from '@vue-macros/named-template';
import { Options as Options$7 } from '@vue-macros/setup-component';
import { Options as Options$8 } from '@vue-macros/setup-sfc';
import { Options as Options$9 } from '@vue-macros/short-emits';

interface FeatureOptionsMap {
    defineModel: Options$1;
    defineOptions: Options$2;
    defineRender: Options$3;
    defineSlots: Options$4;
    hoistStatic: Options$5;
    namedTemplate: Options$6;
    setupComponent: Options$7;
    setupSFC: Options$8;
    shortEmits: Options$9;
}
declare type FeatureName = keyof FeatureOptionsMap;
declare type FeatureOptions = FeatureOptionsMap[FeatureName];
interface OptionsCommon {
    root?: string;
    version?: 2 | 3;
    plugins?: {
        vue?: any;
        vueJsx?: any;
    };
}
declare type OptionalSubOptions<T> = boolean | Omit<T, keyof OptionsCommon> | undefined;
declare type Options = OptionsCommon & {
    [K in FeatureName]?: OptionalSubOptions<FeatureOptionsMap[K]>;
};
declare type OptionsResolved = Required<OptionsCommon> & {
    [K in FeatureName]: false | FeatureOptionsMap[K];
};
declare const _default: unplugin_combine_types.UnpluginCombineInstance<Options | undefined>;

export { FeatureName, FeatureOptions, FeatureOptionsMap, Options, OptionsCommon, OptionsResolved, _default as default };
